<?php

namespace Imunify360;

use \Imunify360\panels\AbstractPanel;


class Request {
    /**
     * @var AbstractPanel
     */
    private $panel;
    private $commands = array('uploadFile', 'applyLicenseFromPanel', 'installation');

    public function __construct(AbstractPanel $panel)
    {
        $this->panel = $panel;
    }

    public function handle()
    {
        if ($post = $this->panel->getPost()) {
            $request = (object) $post;
        } else {
            $request = json_decode($this->panel->getJson());
        }

        $this->panel->request = $request;
        if (isset($request->command)
                && in_array($request->command, $this->commands)
                && $this->panel->isAdmin
                && method_exists($this->panel, $request->command)) {
            $this->panel->{$request->command}();
        } else {
            $this->panel->defaultAction();
        }
    }
}
